Bug 18645 - nptl/tst-cleanupx4 failure on i686
Summary: nptl/tst-cleanupx4 failure on i686
Status: NEW
Alias: None
Product: glibc
Classification: Unclassified
Component: nptl (show other bugs)
Version: 2.24
: P2 normal
Target Milestone: 2.24
Assignee: Not yet assigned to anyone
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-07-08 16:54 UTC by H.J. Lu
Modified: 2016-08-03 12:43 UTC (History)
3 users (show)

See Also:
Host:
Target:
Build:
Last reconfirmed:
fweimer: security-


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description H.J. Lu 2015-07-08 16:54:25 UTC
On Fedora/22 i686, with commit 2e4250225cf894e11c926007698cea8096a372fb,
I got

FAIL: nptl/tst-cleanupx4

[hjl@gnu-6 build-i686-linux]$ cat nptl/tst-cleanupx4.out
test 0
clh (1)
clh (2)
clh (3)
test 1
clh (1)
clh (4)
clh (5)
clh (6)
test 2
clh (7)
clh (8)
global = 64, expected 120
test 3
clh (1)
clh (2)
clh (9)
clh (10)
[hjl@gnu-6 build-i686-linux]$
Comment 1 Carlos O'Donell 2015-07-08 17:20:41 UTC
I see tst-cleanupx4 fail on F22 for i686 with glibc-2.21, so it has to be something that changed earlier.

+ read testcase
+ echo nptl/tst-cleanupx4
nptl/tst-cleanupx4
+ cat nptl/tst-cleanupx4.out
test 0
clh (1)
clh (2)
clh (3)
test 1
clh (1)
clh (4) 
clh (5)
clh (6)
test 2 
clh (7) 
clh (8)
global = 64, expected 120
test 3
clh (1)
clh (2)
clh (9)
clh (10)
Comment 2 H.J. Lu 2015-07-08 19:43:33 UTC
(In reply to Carlos O'Donell from comment #1)
> I see tst-cleanupx4 fail on F22 for i686 with glibc-2.21, so it has to be
> something that changed earlier.

This may be a compiler bug:

https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66334
Comment 3 H.J. Lu 2016-06-01 20:41:09 UTC
tst-cleanupx4.o is the same as tst-cleanup4.c, but compiled with
-fexceptions.  tst-cleanupx4 is linked with tst-cleanupx4.o and
tst-cleanup4aux.o which is compiled without -fexceptions.  Is this
a typo?
Comment 4 cvs-commit@gcc.gnu.org 2016-06-30 03:02:29 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, hjl/pr18645 has been created
        at  34cdba3c2e1e6e9a612c14e6baef2b0ec6ae0fa2 (commit)

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=34cdba3c2e1e6e9a612c14e6baef2b0ec6ae0fa2

commit 34cdba3c2e1e6e9a612c14e6baef2b0ec6ae0fa2
Author: H.J. Lu <hjl.tools@gmail.com>
Date:   Wed Jun 1 14:11:16 2016 -0700

    Compile tst-cleanupx4 test with -fexceptions
    
    tst-cleanupx4 is linked with tst-cleanupx4.o and tst-cleanup4aux.o.
    Since tst-cleanupx4.o is compiled from tst-cleanup4.c with -fexceptions,
    tst-cleanup4aux.c should also be compiled with -fexceptions.
    
    Tested on x86-64 and i686.
    
    	[BZ 18645]
    	* nptl/Makefile (extra-test-objs): Add tst-cleanupx4aux.o.
    	(test-extras): Add tst-cleanupx4aux.
    	(CFLAGS-tst-cleanupx4aux.c): New.  Set to -fexceptions.
    	($(objpfx)tst-cleanupx4): Replace tst-cleanup4aux.o with
    	tst-cleanupx4aux.o.
    	* nptl/tst-cleanupx4aux.c: New file.

-----------------------------------------------------------------------
Comment 5 cvs-commit@gcc.gnu.org 2016-06-30 03:26:14 UTC
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  dfc9ea7b017570ee87d4cbd2bfe62833f0da64e1 (commit)
      from  6a40d8df0c269a953726a432c50702372b86c500 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=dfc9ea7b017570ee87d4cbd2bfe62833f0da64e1

commit dfc9ea7b017570ee87d4cbd2bfe62833f0da64e1
Author: H.J. Lu <hjl.tools@gmail.com>
Date:   Wed Jun 29 20:24:30 2016 -0700

    Compile tst-cleanupx4 test with -fexceptions
    
    tst-cleanupx4 is linked with tst-cleanupx4.o and tst-cleanup4aux.o.
    Since tst-cleanupx4.o is compiled from tst-cleanup4.c with -fexceptions,
    tst-cleanup4aux.c should also be compiled with -fexceptions.
    
    Tested on x86-64 and i686.
    
    	[BZ #18645]
    	* nptl/Makefile (extra-test-objs): Add tst-cleanupx4aux.o.
    	(test-extras): Add tst-cleanupx4aux.
    	(CFLAGS-tst-cleanupx4aux.c): New.  Set to -fexceptions.
    	($(objpfx)tst-cleanupx4): Replace tst-cleanup4aux.o with
    	tst-cleanupx4aux.o.
    	* nptl/tst-cleanupx4aux.c: New file.

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog               |   10 ++++++++++
 nptl/Makefile           |    8 +++++---
 nptl/tst-cleanupx4aux.c |    1 +
 3 files changed, 16 insertions(+), 3 deletions(-)
 create mode 100644 nptl/tst-cleanupx4aux.c
Comment 6 H.J. Lu 2016-06-30 03:27:02 UTC
Fixed for 2.24.